{

35 - server

Pokud je cas odjezdu "mensi" nez pozadovany cas, bere se v potaz tehdy, pokud je
o mene nez 12 hodin pozdeji nez "vetsi" cas

priklad:
Sazava u Zdaru,z.SaZ -> Pribyslav,vlecka SaZ (jede 11:00 a 15:00)
zadan odjezd 22:59 - nenajde
zadan odjezd 23:00 - najde odjezd v 11:00


Neumi hledat spojeni s prestupy, hleda ale spojeni podle pozadavku "pres=..."


Protoze je Data.xml dost velky a nacitani trva dlouho, je mozne nacist jeho
cast (default 10000 radek); pokud chcete nacist cely, zadejte do pole radku
napr. 1000000

Datovy soubor jde vybrat po kliknuti na tlacitko (vlastni data se nacitaji
po kliku na "aktivovat")

testovano s vlastnim klientem

}

unit serverMain;

interface

uses
   Graphics,  Controls,  Forms,  Dialogs,  ActnList,  StdCtrls,  Buttons,  ComCtrls,
     ExtCtrls,
  windows, messages,  SysUtils,  Classes, IdComponent, IdTCPServer, IdHTTPServer,
    IdGlobal, IdBaseComponent, IdThreadMgr, IdThreadMgrDefault,  SyncObjs,
    IdThreadMgrPool, IdIntercept, IdSSLIntercept, IdSSLOpenSSL, xmldom,
  XMLIntf, msxmldom, XMLDoc, ibmxmldom, StrUtils;

type
  TForm1 = class(TForm)
    HTTPServer: TIdHTTPServer;
    alGeneral: TActionList;
    acActivate: TAction;
    edPort: TEdit;
    cbActive: TCheckBox;
    StatusBar1: TStatusBar;
    Label1: TLabel;
    lbStations: TListBox;
    lbLog: TListBox;
    XMLDocument: TXMLDocument;
    edCount: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    OpenDialog1: TOpenDialog;
    Button1: TButton;
    procedure acActivateExecute(Sender: TObject);
    procedure edPortChange(Sender: TObject);
    procedure edPortKeyPress(Sender: TObject; var Key: Char);
    procedure edPortExit(Sender: TObject);
    procedure HTTPServerCommandGet(AThread: TIdPeerThread;
      RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure HTTPServerConnect(AThread: TIdPeerThread);
    procedure HTTPServerDisconnect(AThread: TIdPeerThread);
    procedure HTTPServerStatus(ASender: TObject; const AStatus: TIdStatus;
      const AStatusText: string);
    procedure LoadStations;
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
  private
    UILock: TCriticalSection;
    procedure DisplayMessage(const Msg: string);
    function GetMIMEType(sFile: TFileName): string;
    { Private declarations }
  public
    { Public declarations }
    MIMEMap: TIdMIMETable;
  end;

var
  Form1: TForm1;
  DataFile: string;
  Data: TStringList;

implementation

uses  FileCtrl, IdStack;

{$R *.dfm}

procedure TForm1.acActivateExecute(Sender: TObject);
var
  AppDir: string;
begin
  acActivate.Checked := not acActivate.Checked;
  if not HTTPServer.Active then
    begin
      HTTPServer.Bindings.Clear;
      HTTPServer.DefaultPort := StrToIntDef(edPort.text, 80);
      HTTPServer.Bindings.Add;
    end;

  if acActivate.Checked then
    begin
      // Po aktivaci nacteme data.xml
      Screen.Cursor := crHourGlass;
      Caption := 'Loading...';
      LoadStations;
      Caption := 'Loaded';
      Screen.Cursor := crDefault;;

      try
        HTTPServer.SessionState := False;
        HTTPServer.Active := true;
        DisplayMessage(format('Naslouchn HTTP na %s:%d.', [HTTPServer.Bindings[0].IP, HTTPServer.Bindings[0].Port]));
      except
        on e: exception do
        begin
          acActivate.Checked := False;
          DisplayMessage(format('Nastala vjimka %s "%s".', [e.ClassName, e.Message]));
        end;
      end;
    end
  else
    begin
      HTTPServer.Active := false;
      HTTPServer.Intercept := nil;
      DisplayMessage('Stop naslouchn.');
    end;
  edPort.Enabled := not acActivate.Checked;
end;

procedure TForm1.edPortChange(Sender: TObject);
var
  FinalLength, i: Integer;
  FinalText: string;
begin
  Setlength(FinalText, length(edPort.Text));
  FinalLength := 0;
  for i := 1 to length(edPort.Text) do
    begin
      if edPort.text[i] in ['0'..'9'] then
        begin
          inc(FinalLength);
          FinalText[FinalLength] := edPort.text[i];
        end;
    end;
  SetLength(FinalText, FinalLength);
  edPort.text := FinalText;
end;

procedure TForm1.edPortKeyPress(Sender: TObject; var Key: Char);
begin
  if not(Key in ['0'..'9', #8]) then
    Key := #0;
end;

procedure TForm1.edPortExit(Sender: TObject);
begin
  if Length(Trim(edPort.Text)) = 0 then
    edPort.text := '80';
end;

procedure TForm1.DisplayMessage(const Msg: string);
begin
  UILock.Acquire;
  try
    lbLog.ItemIndex := lbLog.Items.Add(Msg);
  finally
    UILock.Release;
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
  Datafile := ExtractFilePath(Application.ExeName) + 'data.xml';
  UILock := TCriticalSection.Create;
  MIMEMap := TIdMIMETable.Create(true);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  MIMEMap.Free;
  UILock.Free;
end;

function TForm1.GetMIMEType(sFile: TFileName): string;
begin
  Result := MIMEMap.GetFileMIMEType(sFile);
end;

procedure TForm1.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  if cbActive.Checked then
    acActivate.execute;
end;

procedure TForm1.HTTPServerConnect(AThread: TIdPeerThread);
begin
  DisplayMessage('Uivatel pipojen');
end;

procedure TForm1.HTTPServerDisconnect(AThread: TIdPeerThread);
begin
  DisplayMessage('Uivatel odpojen');
end;

procedure TForm1.HTTPServerStatus(ASender: TObject;
  const AStatus: TIdStatus; const AStatusText: string);
begin
  DisplayMessage('Status: ' + aStatusText);
end;

function GetStation(Line: string): string;
begin
  Result := '';
  if (Pos('<stanice ', AnsiLowerCase(Line)) > 0) then
    begin
      Delete(Line, 1, Pos('>', Line));
      Result := Trim(Copy(Line, 1, Pos('<', Line) - 1));
    end;
end;

procedure TForm1.LoadStations;
var
  C1, C2: Integer;
  Line: string;
begin
  Data := TStringList.Create;
  Data.LoadFromFile(Datafile);

  lbStations.Items.Clear;
  lbStations.Sorted := False;

  {

    XMLDocument.Active := False;
    XMLDocument.XML.Assign(Memo1.Lines);
    XMLDocument.Active := True;
    ...

    Pouzil bych tohle, ale ty mamuti 7MB soubory to (alespon na strojich v zadni
    rade) nejak nezvlada, tak se to parsuje rucne... Tato komponenta je pouzita
    v klientovi, kam server odesila jen kratke XML. (Na tomhle pocitaci to
    nezvladal cele rozumne otevrit ani IE)

  }

  for C1 := 0 to Min(StrToInt(edCount.Text), Data.Count - 1) do
    begin
      Caption := 'Loading: ' + IntToStr(Round(C1 / Min(StrToInt(edCount.Text), Data.Count - 1) * 100)) + '%';
      Line := GetStation(Data[C1]);
      if (Line <> '') and (lbStations.Items.IndexOf(Line) = -1) then
        lbStations.Items.Add(Line);
    end;

  lbStations.Sorted := True;
end;

procedure TForm1.HTTPServerCommandGet(AThread: TIdPeerThread;
  RequestInfo: TIdHTTPRequestInfo; ResponseInfo: TIdHTTPResponseInfo);
var
  ResponseText: string;
  C1, C2: Integer;
  Line, ScanningStation, LinkID: string;

  parFrom, parTo, parThrough, LinkDepartStr: string;
  parDepart, LinkDepart: Integer;

  LinkStartIndex, LinkEndIndex: Integer;

  Code, Value: Integer;

  H, M ,S, MS: word;

  ThroughFound: Boolean;
begin
  if (AnsiLowerCase(Trim(RequestInfo.Command)) = 'get') then
    begin
      ///////////////////////////////////
      // Odeslani spojeni
      if (AnsiLowerCase(Trim(RequestInfo.Document)) = '/najdispojeni') then
        begin
          parFrom := '';
          parTo := '';
          parThrough := '';

          // Nastaveni soucasneho casu, pokud neni v dotazu zadan
          DecodeTime(Now, H, M, S, MS);
          parDepart := H * 100 + M;


          // Zjisteni parametru
          for C1 := 0 to RequestInfo.Params.Count - 1 do
            if (Pos('odkud=', AnsiLowerCase(RequestInfo.Params[C1])) > 0) then
              parFrom := AnsiLowerCase(Trim(Copy(RequestInfo.Params[C1], Pos('=', RequestInfo.Params[C1]) + 1, Length(RequestInfo.Params[C1]))))
            else if (Pos('kam=', AnsiLowerCase(RequestInfo.Params[C1])) > 0) then
              parTo := AnsiLowerCase(Trim(Copy(RequestInfo.Params[C1], Pos('=', RequestInfo.Params[C1]) + 1, Length(RequestInfo.Params[C1]))))
            else if (Pos('pres=', AnsiLowerCase(RequestInfo.Params[C1])) > 0) then
              parThrough := AnsiLowerCase(Trim(Copy(RequestInfo.Params[C1], Pos('=', RequestInfo.Params[C1]) + 1, Length(RequestInfo.Params[C1]))))
            else if (Pos('odjezd=', AnsiLowerCase(RequestInfo.Params[C1])) > 0) then
              parDepart := StrToInt(AnsiLowerCase(Trim(Copy(RequestInfo.Params[C1], Pos('=', RequestInfo.Params[C1]) + 1, Length(RequestInfo.Params[C1])))));

          ResponseText := '<Spojeni>' + #13#10;
          LinkID := '';

          if (parFrom <> '') and (parTo <> '') then
            begin
              C1 := 0;
              // Hledame stanici, kde zacit
              while C1 <= Min(StrToInt(edCount.Text), Data.Count - 1) do
                begin
                  if (Pos('<linka', AnsiLowerCase(Data[C1])) > 0) then
                    begin
                      Line := Data[C1];
                      Delete(Line, 1, Pos('"', Line));
                      LinkID := Copy(Line, 1, Pos('"', Line) - 1);
                    end;

                  ScanningStation := GetStation(Data[C1]);
                  // Nasli jsme ji
                  if (AnsiLowerCase(ScanningStation) = parFrom) then
                    begin
                      ThroughFound := False;
                      LinkDepartStr :=   Copy(Data[C1], Pos('odjezd=', Data[C1]) + 8, 2)
                                       + Copy(Data[C1], Pos('odjezd=', Data[C1]) + 11, 2);
                      Val(LinkDepartStr, Value, Code);
                      if (Code = 0) then
                        LinkDepart := Value;

                      // Pokud ma spravny cas, pokracujeme
                      if ((LinkDepart < parDepart) and (LinkDepart + 2400 - parDepart <= 1200)) // Srovnani "mensich" a "vetsich" casu
                      or (LinkDepart >= parDepart) then
                        begin
                          LinkStartIndex := C1;
                          // Hledame (na stejne lince) cilovou stanici (nebo alespon stanici "Pres") 
                          repeat
                            C1 := C1 + 1;
                            Line := GetStation(Data[C1]);

                            // Pokud to klient chtel, zkontrolujeme, jestli jedeme pres pozadovanou stanici
                            if ((parThrough <> '') and (AnsiLowerCase(Line) = parThrough)) then
                              begin
                                ThroughFound := True;
                              end;

                            if (AnsiLowerCase(Line) = parTo)
                            and ((parThrough = '') or (ThroughFound)) then
                              begin
                                LinkEndIndex := C1;
                                ResponseText := ResponseText + '<Spoj>' + #13#10;
                                ResponseText := ResponseText + '<Linka cislo="' + LinkID + '">' + #13#10;
                                for C2 := LinkStartIndex to LinkEndIndex do
                                  ResponseText := ResponseText + Data[C2] + #13#10;
                                ResponseText := ResponseText + '</Linka>' + #13#10;
                                ResponseText := ResponseText + '</Spoj>' + #13#10;
                              end;
                          until (C1 >= Min(StrToInt(edCount.Text), Data.Count - 1)) or (Pos('</linka', AnsiLowerCase(Data[C1])) > 0);
                        end;
                    end;

                  C1 := C1 + 1;
                end;
            end;
          ResponseText := ResponseText + '</Spojeni>' + #13#10;
          ResponseInfo.ContentText := ResponseText;
        end
      ///////////////////////////////////
      // Odeslani seznamu stanic
      else if (AnsiLowerCase(Trim(RequestInfo.Document)) = '/seznamstanic') then
        begin
          ResponseText := '<SeznamStanic>' + #13#10;
          for C1 := 0 to lbStations.Items.Count - 1 do
            ResponseText := ResponseText + '<Stanice>' + lbStations.Items[C1] + '</Stanice>' + #13#10;

          ResponseText := ResponseText + '</SeznamStanic>' + #13#10;

          ResponseInfo.ContentText := ResponseText;
        end
      ///////////////////////////////////
      // Nahlaseni chyby
      else
        begin
          ResponseInfo.ContentText := '<Chyba>Neznm poadavek, nebude zpracovn.</Chyba>' + #13#10;
        end;
    end;

  ///////////////////////////////////
  // Logovani udalosti
  DisplayMessage(Format('%s %s od %s:%d',
    [RequestInfo.Command, RequestInfo.Document,
     AThread.Connection.Binding.PeerIP, AThread.Connection.Binding.PeerPort]));
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  Data.Free;  // uvolneni xml dat
end;

// Vybrani XML souboru
procedure TForm1.Button1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
    Datafile := OpenDialog1.FileName
  else
    Datafile := ExtractFilePath(Application.ExeName) + 'data.xml';
end;

end.

